using System;
using System.Text.Json.Serialization;
namespace org.accordproject.trademark {
   using org.accordproject.address;
   using org.accordproject.geo;
   using org.accordproject.person;
   using org.accordproject.usa.entity;
   using org.accordproject.color;
   using concerto;
   class TrademarkAssetIdentifier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.TrademarkAssetIdentifier";
      public string assetSerialNumber { get; set; }
      public string assetRegistrationNumber { get; set; }
      public Country assetCountry { get; set; }
   }
   class GoodsAndServices : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.GoodsAndServices";
      public string gsDescription { get; set; }
      public string intlClass { get; set; }
      public string usClass { get; set; }
      public string currentFilingBasis { get; set; }
      public string origFilingBasis { get; set; }
   }
   class Owner : Person {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.Owner";
   }
   class Registrant : Person {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.Registrant";
   }
   class Assignee : Person {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.Assignee";
   }
   class Correspondent : Person {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.Correspondent";
   }
   class Attorney : Person {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.Attorney";
   }
   enum MarkStatus {
      Live,
      Dead,
   }

   enum MarkType {
      Standard_Character,
      Special_Form,
      Sound,
   }

   enum Register {
      Principal,
      Supplemental,
   }

   class TrademarkAsset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.trademark.TrademarkAsset";
      public TrademarkAssetIdentifier assetIdentifier { get; set; }
      public string encodedMarkImage { get; set; }
      public string markDescription { get; set; }
      public GoodsAndServices[] goodsandServices { get; set; }
      public Owner originalOwner { get; set; }
      public EntityType entityType { get; set; }
      public Registrant originalRegistrant { get; set; }
      public Assignee currentAssignee { get; set; }
      public Correspondent currentCorrespondent { get; set; }
      public Attorney attorneyRepresentative { get; set; }
      public MarkStatus markStatus { get; set; }
      public MarkType markType { get; set; }
      public Register register { get; set; }
      public string literalElement { get; set; }
      public bool colorClaim { get; set; }
      public Color[] colorFeature { get; set; }
      public DateTime filingDate { get; set; }
      public DateTime registrationDate { get; set; }
   }
}
